with Text_Io, Console_Io, Ada.Characters.Handling;
use  Text_Io;
procedure Test_Console is
  
  procedure Convert_Digit_String_To_Char(S: in out String; N: in out Integer) is
    Pos: Integer;
    Ch: Character;
  begin
    if N = 3 then
      Pos:=Integer'Value(S(1..N));
      Ch:=Character'Val(Pos);
      N:=1;
      S(1):=Ch;
    end if;
  exception
    when others =>
      null;
  end;
  
  procedure Show_Graphic_Chars is
    Graphic_Chars: String(1..256);
    N:Integer:=0;
    Ch: Character;
    N1,N2: Integer;
  begin
    for J in 0..1 loop
      N:=0;
      N1:=J*128;
      N2:=N1+127;
      for I in N1..N2 loop
        Ch:=Character'Val(I);
        if Ada.Characters.Handling.Is_Graphic(Ch) then 
          N:=N+1; 
          Graphic_Chars(N):=Ch; 
        end if;
      end loop;
      declare
        St:String:=
          Integer'Image(N)&
          " Graphic characters ("
            &Integer'Image(N1)&"-"&
            Integer'Image(N2)&"):"&
            Graphic_Chars(1..N)&';';
      begin
        
        Console_Io.Put_Line("Console_IO: "&St);
        Text_Io.Put_Line   ("   Text_IO: "&St);
        New_Line;
      end;
    end loop;
    
  end;
  
  
  procedure User_Controlled_Verification is
    S,T: String(1..256);
    N,M: Integer;
    F: File_Type;
    C1,C2: Character;
    
  begin
    
    Create(F,Out_File,"Test.Txt");
    New_Line;
    Text_Io.Put_Line("Enter a 3-digit Character'Pos or any String,  CR to exit"); 
    loop
      New_Line;
      M:=N;
      Console_Io.Get_Line(S,N);
      exit when N=0;
      
      Convert_Digit_String_To_Char(S,N);  
      
      for I in 1..N loop
        Console_Io.Put(S(I)&":"&Integer'Image(Character'Pos(S(I))+1000)(3..5)&" ");
      end loop;
      New_Line;
      
      Text_Io.Put_Line     (S(1..N)&" (using Text_IO.Put)");
      Console_Io.Put_Line  (S(1..N)&" (using Console_IO.Put)");
      
      Put_Line(F,S(1..N));
    end loop;
    Close (F);
    
    Open  (F,In_File, "Test.txt");
    Put_Line("Check of Text_io to/from file:");
    loop
      exit when End_Of_File(F);
      Text_Io.Get_Line(F,S,N);
      Console_Io.Put_Line(S(1..N));
    end loop;
    Put_Line("All input re-read");
  end;
  
begin
  Put_Line("Console_IO verification");
  New_Line;
  Show_Graphic_Chars;
  User_Controlled_Verification;
end;

